#!/usr/bin/perl -w

################################################################################
#
# Logviewer for BlueBox
#
# Displays logfiles humanreadable in webbrowser
#
################################################################################
# St. Wagner (c) 2004                                                          #
################################################################################
#
# Version 0.01
# 
################################################################################
use strict;
use CGI;
use CGI::Carp 'fatalsToBrowser';

use Config_param;
use CGI_Parameter;
use HTML_Darstellung;
use Array;
################################################################################
my $script = $ENV{'SCRIPT_NAME'};

################################################################################
&startDocument($q, 'Logviewer');

&startDesign();


if($cgi_param{'viewtype'} eq 'Table') {
    &view_last_lines_table();
}
elsif($cgi_param{'viewtype'} eq 'List') {
    &view_last_lines_list();
}

&endDesgin();
&endDocument($script);





################################################################################
sub startDesign {
    print "<table border=\"0\" width=\"100%\">\n"
	."<tr><td width=\"$conf_page_style{'space_left'}\"></td>"
	."<td>\n";

    &print_select_function($script, %cgi_param);
    
    print "</td>\n<td width=\"$conf_page_style{'space_right'}\"></td></tr>\n";

    # Row for Pagecontent
    print"<tr><td width=\"$conf_page_style{'space_left'}\"></td><td>";
}

################################################################################
sub endDesgin {

    print "</td><td width=\"$conf_page_style{'space_right'}\"></td></tr>\n";
    print "</table>\n";
}


################################################################################
sub print_select_function {
    my ($script, %param) = @_;

    print "<form action=\"$script\" method=\"POST\">\n";
    
    print "<table border=\"0\"><tr>\n";

    print "<td>View Style:</td><td>";
    if($param{'viewtype'} eq 'List') {
	print "<input type=\"radio\" name=\"viewtype\" value=\"List\" checked>";
    }
    else {
	print "<input type=\"radio\" name=\"viewtype\" value=\"List\">";
    }
    print " List\n";

    
    if($param{'viewtype'} eq 'Table') {
	print "<input type=\"radio\" name=\"viewtype\" value=\"Table\" checked>";
    }
    else {
	print "<input type=\"radio\" name=\"viewtype\" value=\"Table\">";
    }

    print " Table</td><td>&nbsp;</td><td>&nbsp;</td>"
	."<td align=\"right\"><input type=\"submit\" name=\"submit\" value=\"View\"></td></tr>\n";

    # Loglevel -----------------------------------
    print "<tr><td valign=\"top\">View Loglevel:</td>"
	."<td valign=\"top\">";

    if(&is_in_array('info', @{$param{'loglevel'}})) {
	print "<input type=\"checkbox\" name=\"loglevel\" value=\"info\" checked>";
    }
    else {
	print "<input type=\"checkbox\" name=\"loglevel\" value=\"info\">";
    }
    print "Info<br>\n";

    if(&is_in_array('message', @{$param{'loglevel'}})) {
	print "<input type=\"checkbox\" name=\"loglevel\" value=\"message\" checked>";
    }	
    else {
	print "<input type=\"checkbox\" name=\"loglevel\" value=\"message\">";
    }
    print  "Message<br>\n";

    if(&is_in_array('warn', @{$param{'loglevel'}})) {
	print "<input type=\"checkbox\" name=\"loglevel\" value=\"warn\" checked>";
    }
    else {
	print "<input type=\"checkbox\" name=\"loglevel\" value=\"warn\">";
    }
    print " Warn<br></td>\n";

    # Details ------------------------------------
    print "<td valign=\"top\">Details:</td><td>";

    if($param{'highlight'} eq 'on') {
	print "<input type=\"checkbox\" name=\"highlight\" value=\"on\" checked>";
    }
    else {
	print "<input type=\"checkbox\" name=\"highlight\" value=\"on\">";
    }
    print " Hightlight Loglevel<br>\n";
    if($param{'linenumber'} eq 'on') {
	print "<input type=\"checkbox\" name=\"linenumber\" value=\"on\" checked>";
    }
    else {
	print "<input type=\"checkbox\" name=\"linenumber\" value=\"on\">";
    }
    print " Linenumbers<br>\n";

    if($param{'autoscroll'} eq 'on') {
	print "<input type=\"checkbox\" name=\"autoscroll\" value=\"on\" checked>";
    }
    else {
	print "<input type=\"checkbox\" name=\"autoscroll\" value=\"on\">";
    }
    print " Autoscroll\n";

    print " in interval "
	."<input type=\"input\" name=\"interval\" size=\"3\" maxlength=\"5\" value=\"$param{'interval'}\"> sec</td>\n";
    print "<td>View last "
	."<input type=\"input\" name=\"maxlines\" size=\"5\" maxlength=\"7\" value=\"$param{'maxlines'}\"> lines</td></tr>\n";

# switch of until next version !!!
    if(0) {
    if($param{'viewtype'} eq 'Table') {
	print "<tr><td>View cols:</td><td colspan=\"4\">";
	if(&is_in_array('time', @{$param{'cols'}})) {
	    print "<input type=\"checkbox\" name=\"cols\" value=\"time\" checked>";
	}
	else {
	    print "<input type=\"checkbox\" name=\"cols\" value=\"time\">";
	}
	print " Time\n";

	if(&is_in_array('loglevel', @{$param{'cols'}})) {
	    print "<input type=\"checkbox\" name=\"cols\" value=\"loglevel\" checked>";
	}
	else {
	    print "<input type=\"checkbox\" name=\"cols\" value=\"loglevel\">";
	}
	print " Loglevel\n";

	if(&is_in_array('src', @{$param{'cols'}})) {
	    print "<input type=\"checkbox\" name=\"cols\" value=\"src\" checked>";
	}
	else {
	    print "<input type=\"checkbox\" name=\"cols\" value=\"src\">";
	}
	print " Source\n";

	if(&is_in_array('dst', @{$param{'cols'}})) {
	    print "<input type=\"checkbox\" name=\"cols\" value=\"dst\" checked>";
	}
	else {
	    print "<input type=\"checkbox\" name=\"cols\" value=\"dst\">";
	}
	print " Destination";

	print "</td></tr>\n";
    }
  } # switched of until next version

    print "</table>\n"
	."</form>\n";
    
 }

################################################################################
sub view_last_lines_list {
    
    my @logfile;
    my $i;

    @logfile = &get_and_limit_logfile();

    @logfile = &filter_logfile(@logfile);
    
    print "<table border=\"1\" width=\"100%\"><tr><td>";
    if($cgi_param{'linenumber'} eq 'on') {
	for($i=1; $i <= @logfile; $i++) {
	    if($cgi_param{'highlight'} eq 'on') {
		print "$i: ".&highlight_logfile_line($logfile[$i-1])."<br>\n";
	    }
	    else {
		print "$i: $logfile[$i-1]<br>\n";
	    }
	}
    }
    else {
	foreach (@logfile) {
	    if($cgi_param{'highlight'} eq 'on') {
		print &highlight_logfile_line($_)."<br>\n";
	    }
	    else {
		print "$_<br>\n";
	    }
	}
    }
    print "</td></tr></table>\n";


}


################################################################################
sub get_and_limit_logfile {

    my @logfile;

    open(LOGFILE, "<$conf_logfile{'logfile'}") 
	|| &message_error(1, "Unable to open Logfile: $conf_logfile{'loglfile'}");
    @logfile = <LOGFILE>;
    close(LOFGILE);

    if(@logfile > $cgi_param{'maxlines'} ) {
	splice(@logfile, 0, @logfile- $cgi_param{'maxlines'});
    }

    return (@logfile);
}

################################################################################
sub highlight_logfile_line {
    my ($line) = @_;

    if($line =~ m/user.warn/i) {
	$line = "<font color=\"red\">$line</font>";
    }

    return($line);
}

################################################################################
sub filter_logfile {
    my (@logfile) = @_;

    my $i;

    for($i=0; $i < @logfile; $i++) {
	# remove empty lines
	if($logfile[$i] =~ m/^\s*$/) {
	    splice(@logfile, $i, 1);
	    $i--;
	}
	if(!&is_in_array('info', @{$cgi_param{'loglevel'}})) {
	    if($logfile[$i] =~ m/user\.info/) {
		splice(@logfile, $i, 1);
		$i--;
	    }
	}
	if(!&is_in_array('warn', @{$cgi_param{'loglevel'}})) {
	    if($logfile[$i] =~ m/user\.warn/) {
		splice(@logfile, $i, 1);
		$i--;
	    }
	}
    }
    
    return (@logfile);
}
################################################################################
sub view_last_lines_table {
    
    my @logfile;

    @logfile = &get_and_limit_logfile();

    @logfile = &filter_logfile(@logfile);
    
    # change from 1 dim array to two dim array !
    @logfile = &split_logfile(@logfile);

    # add headline to array
    my @header = ('Time', 'Host', 'Service', 'Message');

    if($cgi_param{'linenumber'} eq 'on') {
	@logfile = &add_linenumber_col_array(@logfile);
	unshift(@header, 'No');
    }


    my %logfile = ('header' => \@header,
		   'array' => \@logfile);
    %logfile = &add_headline_to_array(%logfile);
    
    &print_table_array( &form_table_array (@{$logfile{'array'}}) );

}

################################################################################
sub add_linenumber_col {
    my ($content, @array) = @_;

    unshift(@array, $content);
    return(@array);
}

################################################################################
sub add_linenumber_col_array {
    my ($content, @array) = @_;

    for(my $i=0; $i < @array; $i++) {
        my @tmp = &add_linenumber_col($i+1, @{$array[$i]});
        $array[$i] = \@tmp;
    }

    return(@array);
}
################################################################################
sub split_logfile {
    my (@logfile) = @_;

    my @log_array;
    my $line;
    
    foreach $line (@logfile) {
	my @tmp = &split_logfile_entry($line);
	push(@log_array, \@tmp);
    }    

    return (@log_array);
}


################################################################################
sub split_logfile_entry {
    my ($line) = @_;

    my @values; # = split(/ /, $line);
#Mar 10 15:01:36 smoothwall user.info klogd: fw: end:INPUT IN=eth0 OUT= MAC=ff:ff:ff:ff:ff:ff:00:05:5d:a2:b6:0b:08:00 SRC=134.76.82.174 DST=134.76.82.255 LEN=78 TOS=0x00 PREC=0x00 TTL=128 ID=34304 PROTO=UDP SPT=137 DPT=137 LEN=58

    $line =~ m/^(\w\w\w\s+\d{1,2}\s+\d\d:\d\d:\d\d)\s+(\w+)\s+(\w+\.\w+)\s+(\w+):\s+(.*)$/;
    push(@values, $1);
    push(@values, $2);
    push(@values, $3);
    push(@values, $4);

    # filter in second step
    $line = $5;
    $line =~ m/^(\w+):\s+([\w:]+)\s+IN=(\w*)\s+OUT=(\w*)\s+(MAC=[0-9a-f:]+)*\s*(.*)$/;
    push(@values, $1);
    push(@values, $2);
    push(@values, $3);
    push(@values, $4);
    push(@values, $5);

    $line = $6;
#    $line =~ m/^SRC=(\d+\.\d+\.\d+)\s+(.*)$/;
    $line =~ m/^SRC=([\w\.]+)\s+DST=([\w\.]+)\s+LEN=(\w+)\s+TOS=(\w+)\s+PREC=(\w+)\s+TTL=(\w+)\s+ID=(\w+)\s+(.*)$/;
    push(@values, $1);
    push(@values, $2);
    push(@values, $3);
    push(@values, $4);
    push(@values, $5);
    push(@values, $6);
    push(@values, $7);
    push(@values, $8);
#    push(@values, $line);


    # remove whitespaces befor and behind the values
    for(my $i=0; $i < @values; $i++) {
	$values[$i] =~ s/^\s*//;
	$values[$i] =~ s/\s*$//;
    }
    
    return (@values);
}

################################################################################
sub message_error {
    my ($status, @messages) = @_;

    my $line;
    foreach $line (@messages) {
	print "$line\n";
    }

    if(($status == 1) or ($status eq 'die')) {
	die();
    }

}

